<?php

namespace App\modele;

<<<<<<< HEAD
use App\gateway\AlumniGateway;
use App\gateway\Connection;
use App\gateway\ImageGateway;
use App\gateway\OffreGateway;
use App\gateway\ProfilGateway;
use App\metier\Alumni;
use mysql_xdevapi\Exception;
=======
use App\gateway\ImageManager;
use App\metier\Alumni;
use App\metier\Offre;
>>>>>>> master

class MembreModele extends UtilisateurModele
{

    private $con;

    public function __construct()
    {
        $this->con = new Connection(DB_HOST,DB_USER,DB_PASS);
    }

    /**
     * @description modifier photo de profil
     */
    public function updateProfilPhoto() : bool
    {
        // TO DO
        return false;
    }

    /**
     * @description ajouter formation
     */
    public function addFormation() : bool
    {
        // TO DO
        return false;
    }


    /**
     * @description modifier formation
     */
    public function updateFormation() : bool
    {
        // TO DO
        return false;
    }

    /**
     * @description Récupérer l'expériences en fonction de l'id
     */
    public function getExperienceById() : array 
    {
        $gate = new ExperiencetGateway($this->con);
        $data = $gate->getExperienceFromId();
        $experience = array();

        foreach($data as $row)
        {
            $experience[] = new Experience(
                $row['id'],
                $row['profil'],
                $row['intitule'],
                $row['dateBegin'],
                $row['dateEnd'],
                $row['industryName'],
                $row['currentJob']
            );
        }
        return $experience;
    }

    /**
     * @description Récupérer les expériences de l'utilisateurs en cours
     */
    public function getExperienceByProfil() : array 
    {
        $gate = new ExperiencetGateway($this->con);
        $data = $gate->getExperienceFromProfil();
        $experience = array();

        foreach($data as $row)
        {
            $experience[] = new Experience(
                $row['id'],
                $row['profil'],
                $row['intitule'],
                $row['dateBegin'],
                $row['dateEnd'],
                $row['industryName'],
                $row['currentJob']
            );
        }
        return $experience;
    }

    /**
     * @description ajouter Experience
     */
    public function addExperience()
    {
        $gate = new ExperienceGateway($this->con);

        $exp = new Experience(
            $gate->getNewId(),
            '1', //TODO : Ajouter l'ID de l'admin connecté
            $titre,
            $description,
            $date,
            $nbPlaceMax,
            $img
        );

        $gate->insertEvenement($evenement);
    }

    /**
     * @description supprimer une expérience
     */
    public function deleteExperience(int $id)
    {
        $gate = new ExperienceGateway($this->con);
        $gate->deleteExperience($id);
    }

    /**
     * @description modifier experience
     */
    public function updateExperience() : bool
    {
        // TO DO
        return false;
    }

    /**
     * @description changer mot de passe
     * @param string $oldHash ancien hash
     * @param string $newHash nouveau hash
     */
    public function updatePasswd(string $oldHash,string $newHash) : bool
    {
        // TO DO
        return false;
    }



    public function publishOffer(string $img, string $logo)
    {
        $desc = $_POST["description"];
        $descposte = $_POST["descriptPoste"];
        $nom = $_POST["name"];
        $ville = $_POST["ville"];
        $entreprise = $_POST["entreprise"];
        $profilRecherche = $_POST["profilRecherche"];
        $mail = $_POST["mail"];
        $num = $_POST["num"];
        $site = $_POST["site"];
        $exp = $_POST["choixExp"];
        $typeContrat = $_POST["typeContrat"];
        $niveauEtudes = $_POST["education"];
        $date = new \DateTime();

        if(isset($_POST["fullRemote"]))
        {
            $remote = true;
        }
        else $remote = false;

        // à la place de NULL passer id utilisateur créateur offre
        $offre = new Offre($this->offreGw->getNewId(),
            new Alumni(intval($_SESSION['id']),"test.mail@icloud.fr","",$_SESSION['role'],$_SESSION['nom'],$_SESSION['prenom']),
            $nom,
            $desc,
            $img,
            $logo,
            $typeContrat,
            $ville,
            $entreprise,
            $descposte,
            $profilRecherche,
            $exp,
            $niveauEtudes,
            $mail,
            $num,
            $site,
            $remote,
            $date);

        $this->offreGw->addOffers($offre);

        return $offre;
    }

    public function deleteOffer(Offre $offre)
    {
        $this->offreGw->deleteOffer($offre->getId());
        ImageManager::deleteImg($offre->getImg());
        ImageManager::deleteImg($offre->getLogo());

    }


}